/*
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: smcert.c,v 1.1 2009/08/09 00:54:07 ca Exp $")
#include "sm/error.h"
#include "sm/assert.h"
#include "sm/io.h"
#include "sm/tls.h"

#if MTA_USE_TLS

/*
**  SM_TLS_GET_CN -- extract CN from an X509 name
**
**	Parameters:
**		x509_name -- X509 name
**		nid -- index
**		str -- where to write result (output)
**
**	Returns:
**		usual error code
*/

sm_ret_T
sm_tls_get_cn(X509_NAME *x509_name, int nid, sm_str_P str)
{
	int r;
	char buf[SM_X509_MAXNAME];

#define CHECK_X509_NAME	do {	\
		if (r == -1)	\
			strlcpy(buf, "BadCert:Unknown", sizeof(buf));	\
		else if ((size_t)r >= sizeof(buf) - 1)	\
			strlcpy(buf, "BadCert:TooLong", sizeof(buf));	\
		else if ((size_t)r > strlen(buf))	\
			strlcpy(buf, "BadCert:ContainsNUL", sizeof(buf));	\
	} while (0)

	r = X509_NAME_get_text_by_NID(x509_name, nid, buf, sizeof buf);
	CHECK_X509_NAME;
	TLS_SET_XSTR(buf, str);

	return SM_SUCCESS;
}
#endif /* MTA_USE_TLS */
